2021-07-24 13:53:02 +00:00
name : 'Build'
2021-12-24 19:35:25 +00:00
on :
2021-08-17 14:45:23 +00:00
push :
branches :
- dev
- "release*"
tags :
2021-08-19 09:56:42 +00:00
- '*'
2021-08-17 14:45:23 +00:00
pull_request :
2021-07-24 13:53:02 +00:00
env :
2022-03-23 17:59:20 +00:00
TARGETS : f7
2021-10-12 15:30:55 +00:00
DEFAULT_TARGET : f7
2021-07-24 13:53:02 +00:00
jobs :
2021-12-24 19:35:25 +00:00
main :
runs-on : [ self-hosted,Office]
2021-07-24 13:53:02 +00:00
steps :
- name : 'Cleanup workspace'
uses : AutoModality/action-clean@v1
- name : 'Decontaminate previous build leftovers'
run : |
2021-07-25 11:46:34 +00:00
if [ -d .git ]
then
git submodule status \
|| git checkout `git rev-list --max-parents=0 HEAD | tail -n 1`
fi
2021-07-24 13:53:02 +00:00
- name : 'Checkout code'
uses : actions/checkout@v2
with :
fetch-depth : 0
submodules : true
2021-08-26 17:59:23 +00:00
ref : ${{ github.event.pull_request.head.sha }}
2021-07-24 13:53:02 +00:00
- name : 'Build docker image'
uses : ./.github/actions/docker
- name : 'Make artifacts directory'
run : |
test -d artifacts && rm -rf artifacts || true
mkdir artifacts
2022-04-13 20:50:25 +00:00
2021-08-20 17:31:07 +00:00
- name : 'Generate suffix and folder name'
2021-08-26 17:59:23 +00:00
id : names
2021-08-20 17:31:07 +00:00
run : |
REF=${{ github.ref }}
if [[ ${{ github.event_name }} == 'pull_request' ]]; then
REF=${{ github.head_ref }}
fi
2021-10-17 09:41:04 +00:00
BRANCH_OR_TAG=${REF#refs/*/}
2021-08-26 17:59:23 +00:00
SHA=$(git rev-parse --short HEAD)
2022-04-13 20:50:25 +00:00
2021-08-20 17:31:07 +00:00
if [[ "${{ github.ref }}" == "refs/tags/"* ]]; then
2021-10-17 09:41:04 +00:00
SUFFIX=${BRANCH_OR_TAG//\//_}
2021-08-20 17:31:07 +00:00
else
2021-10-17 09:41:04 +00:00
SUFFIX=${BRANCH_OR_TAG//\//_}-$(date +'%d%m%Y')-${SHA}
2021-08-20 17:31:07 +00:00
fi
2022-04-13 20:50:25 +00:00
2021-08-26 17:59:23 +00:00
echo "WORKFLOW_BRANCH_OR_TAG=${BRANCH_OR_TAG}" >> $GITHUB_ENV
2021-11-18 08:46:47 +00:00
echo "DIST_SUFFIX=${SUFFIX}" >> $GITHUB_ENV
2021-08-26 17:59:23 +00:00
echo "::set-output name=artifacts-path::${BRANCH_OR_TAG}"
echo "::set-output name=suffix::${SUFFIX}"
echo "::set-output name=short-hash::${SHA}"
2021-09-10 12:05:09 +00:00
echo "::set-output name=default-target::${DEFAULT_TARGET}"
2021-07-24 13:53:02 +00:00
2021-12-01 10:21:26 +00:00
- name : 'Bundle scripts'
if : ${{ !github.event.pull_request.head.repo.fork }}
run : |
tar czpf artifacts/flipper-z-any-scripts-${{steps.names.outputs.suffix}}.tgz scripts
2022-01-02 21:39:56 +00:00
- name : 'Rebuild Assets'
uses : ./.github/actions/docker
with :
run : |
set -e
make -C assets clean
make -C assets
2022-04-18 23:09:11 +00:00
git diff --quiet || ( echo "Assets recompilation required."; exit 255 )
2022-01-02 21:39:56 +00:00
2021-11-18 08:46:47 +00:00
- name : 'Build the firmware in docker'
2021-07-24 13:53:02 +00:00
uses : ./.github/actions/docker
with :
run : |
2021-12-09 04:58:07 +00:00
set -e
2021-07-24 13:53:02 +00:00
for TARGET in ${TARGETS}
do
2022-04-13 20:50:25 +00:00
make updater_package TARGET=${TARGET} ${{ startsWith(github.ref, 'refs/tags') && 'DEBUG=0 COMPACT=1' || '' }}
2021-10-26 15:33:38 +00:00
done
2021-07-24 13:53:02 +00:00
- name : 'Move upload files'
2021-08-17 16:46:12 +00:00
if : ${{ !github.event.pull_request.head.repo.fork }}
2021-07-24 13:53:02 +00:00
uses : ./.github/actions/docker
with :
run : |
2021-12-09 04:58:07 +00:00
set -e
2021-07-24 13:53:02 +00:00
for TARGET in ${TARGETS}
do
2021-11-18 08:46:47 +00:00
mv dist/${TARGET}/* artifacts/
2021-07-24 13:53:02 +00:00
done
2022-04-13 20:50:25 +00:00
- name : 'Bundle self-update package'
if : ${{ !github.event.pull_request.head.repo.fork }}
2022-04-14 17:05:45 +00:00
uses : ./.github/actions/docker
with :
run : |
set -e
for UPDATEBUNDLE in artifacts/*/
do
BUNDLE_NAME=`echo $UPDATEBUNDLE | cut -d'/' -f2`
echo Packaging ${BUNDLE_NAME}
tar czpf artifacts/flipper-z-${BUNDLE_NAME}.tgz -C artifacts ${BUNDLE_NAME}
rm -rf artifacts/${BUNDLE_NAME}
done
2022-04-13 20:50:25 +00:00
2021-12-01 10:21:26 +00:00
- name : 'Bundle resources'
if : ${{ !github.event.pull_request.head.repo.fork }}
run : |
./scripts/assets.py manifest assets/resources
tar czpf artifacts/flipper-z-any-resources-${{steps.names.outputs.suffix}}.tgz -C assets resources
2021-08-17 09:41:08 +00:00
- name : 'Bundle core2 firmware'
2021-08-17 16:46:12 +00:00
if : ${{ !github.event.pull_request.head.repo.fork }}
2021-08-17 09:41:08 +00:00
run : |
test -d core2_firmware && rm -rf core2_firmware || true
mkdir core2_firmware
2021-09-13 09:52:50 +00:00
./scripts/assets.py copro lib/STM32CubeWB core2_firmware STM32WB5x
2021-08-26 17:59:23 +00:00
tar czpf artifacts/flipper-z-any-core2_firmware-${{steps.names.outputs.suffix}}.tgz core2_firmware
2021-08-17 09:41:08 +00:00
2021-07-24 13:53:02 +00:00
- name : 'Upload artifacts to update server'
2021-08-17 16:46:12 +00:00
if : ${{ !github.event.pull_request.head.repo.fork }}
2021-10-17 09:41:04 +00:00
uses : burnett01/rsync-deployments@5.1
2021-07-24 13:53:02 +00:00
with :
2021-10-17 09:41:04 +00:00
switches : -avzP --delete --mkpath
2021-07-24 13:53:02 +00:00
path : artifacts/
2021-08-26 17:59:23 +00:00
remote_path : "${{ secrets.RSYNC_DEPLOY_BASE_PATH }}${{steps.names.outputs.artifacts-path}}/"
2021-07-24 13:53:02 +00:00
remote_host : ${{ secrets.RSYNC_DEPLOY_HOST }}
remote_port : ${{ secrets.RSYNC_DEPLOY_PORT }}
remote_user : ${{ secrets.RSYNC_DEPLOY_USER }}
remote_key : ${{ secrets.RSYNC_DEPLOY_KEY }}
- name : 'Trigger update server reindex'
2021-08-17 16:46:12 +00:00
if : ${{ !github.event.pull_request.head.repo.fork }}
2021-07-24 13:53:02 +00:00
uses : wei/curl@master
with :
args : -X POST -F 'key=${{ secrets.REINDEX_KEY }}' ${{ secrets.REINDEX_URL }}
2021-09-10 12:05:09 +00:00
- name : 'Find Previous Comment'
2021-08-26 17:59:23 +00:00
if : ${{ !github.event.pull_request.head.repo.fork && github.event.pull_request }}
uses : peter-evans/find-comment@v1
id : fc
with :
issue-number : ${{ github.event.pull_request.number }}
comment-author : 'github-actions[bot]'
body-includes : 'to flash the'
2021-09-10 12:05:09 +00:00
- name : 'Create or update comment'
2021-08-26 17:59:23 +00:00
if : ${{ !github.event.pull_request.head.repo.fork && github.event.pull_request}}
uses : peter-evans/create-or-update-comment@v1
with :
comment-id : ${{ steps.fc.outputs.comment-id }}
issue-number : ${{ github.event.pull_request.number }}
body : |
2021-12-16 12:28:42 +00:00
[ Click here](https://update.flipperzero.one/?url=https://update.flipperzero.one/builds/firmware/${{steps.names.outputs.artifacts-path}}/flipper-z-${{steps.names.outputs.default-target}}-full-${{steps.names.outputs.suffix}}.dfu&channel=${{steps.names.outputs.artifacts-path}}&version=${{steps.names.outputs.short-hash}}&target=${{steps.names.outputs.default-target}}) to flash the `${{steps.names.outputs.short-hash}}` version of this branch via WebUSB.
2021-08-26 17:59:23 +00:00
edit-mode : replace
2022-01-02 21:39:56 +00:00
2021-12-24 19:35:25 +00:00
compact :
if : ${{ !startsWith(github.ref, 'refs/tags') }}
runs-on : [ self-hosted,koteeq]
steps :
- name : 'Cleanup workspace'
uses : AutoModality/action-clean@v1
- name : 'Decontaminate previous build leftovers'
run : |
if [ -d .git ]
then
git submodule status \
|| git checkout `git rev-list --max-parents=0 HEAD | tail -n 1`
fi
- name : 'Checkout code'
uses : actions/checkout@v2
with :
fetch-depth : 0
submodules : true
ref : ${{ github.event.pull_request.head.sha }}
- name : 'Build docker image'
uses : ./.github/actions/docker
2022-04-13 20:50:25 +00:00
2021-12-24 19:35:25 +00:00
- name : 'Generate suffix and folder name'
id : names
run : |
REF=${{ github.ref }}
if [[ ${{ github.event_name }} == 'pull_request' ]]; then
REF=${{ github.head_ref }}
fi
BRANCH_OR_TAG=${REF#refs/*/}
SHA=$(git rev-parse --short HEAD)
2022-04-13 20:50:25 +00:00
2021-12-24 19:35:25 +00:00
if [[ "${{ github.ref }}" == "refs/tags/"* ]]; then
SUFFIX=${BRANCH_OR_TAG//\//_}
else
SUFFIX=${BRANCH_OR_TAG//\//_}-$(date +'%d%m%Y')-${SHA}
fi
2022-04-13 20:50:25 +00:00
2021-12-24 19:35:25 +00:00
echo "WORKFLOW_BRANCH_OR_TAG=${BRANCH_OR_TAG}" >> $GITHUB_ENV
echo "DIST_SUFFIX=${SUFFIX}" >> $GITHUB_ENV
2022-01-02 21:39:56 +00:00
- name : 'Rebuild Assets'
uses : ./.github/actions/docker
with :
run : |
set -e
make -C assets clean
make -C assets
2021-12-24 19:35:25 +00:00
- name : 'Build the firmware in docker'
uses : ./.github/actions/docker
with :
run : |
set -e
for TARGET in ${TARGETS}
do
make TARGET=${TARGET} DEBUG=0 COMPACT=1
2022-01-02 21:39:56 +00:00
done